#include<stdio.h>
#include<math.h>

typedef enum { FALSO, VERO } Bool;

typedef struct {
  float x, y;
} punto;

typedef struct {
  punto p1;
  punto p2;
} rettangolo;

rettangolo nuovo( punto *p1, punto *p2 );
void stampa( rettangolo *r );
float area( rettangolo *r );
punto centro( rettangolo *r );
rettangolo *trasla( rettangolo *r, float x, float y );
Bool dentro( punto *p, rettangolo *r );


int main( void ){

  punto a = {0,0}, b = {3, 10}, p = {-1, 2};
  rettangolo r;
   
  r = nuovo( &a, &b );
  
  printf( "\n" );
  stampa( &r );
  printf( "L'area del rettangolo vale %f\n", area( &r ) );
  printf( "Il centro del rettangolo ? (%f, %f)\n", centro( &r ).x, centro( &r ).y );
  printf( "Il punto (%f, %f)%s cade dentro al rettangolo\n", p.x, p.y, dentro( &p, &r ) ? "" : " non" );
  printf( "Traslo di 3 e 4: \n" );
  trasla( &r, 3, 4 );
  stampa( &r );
  printf( "\n" );
  
  return 0;

}


/* crea un nuov rettangolo a partire da due punti */
rettangolo nuovo( punto *p1, punto *p2 ){
  rettangolo r;
  
  r.p1.x = p1 -> x;
  r.p1.y = p1 -> y;
  r.p2.x = p2 -> x;
  r.p2.y = p2 -> y;
  
  return r;
}


/* stampa i dati che caratterizzano il rettangolo puntato da r*/
void stampa( rettangolo *r ) {
  printf( "Rettangolo di vertici (%f, %f) e (%f, %f).\n", r -> p1.x, r -> p1.y, r -> p2.x, r -> p2.y );
}

/* restituisce l'area della figura. 
   restituisce 0 se non e' R, Q, n? C 
*/
float area( rettangolo *r ) {
  return ( r -> p2.x - r -> p1.x ) * ( r -> p2.y - r -> p1.y );
}

/* restituisce il centro della figura.
*/
punto centro( rettangolo *r ) {
  punto centro;
  centro.x = ( r -> p2.x - r -> p1.x ) / 2;
  centro.y = ( r -> p2.y - r -> p1.y ) / 2;
  return centro;
}

rettangolo *trasla( rettangolo *r, float x, float y ) {
    r -> p1.x += x;
    r -> p2.x += x;
    r -> p1.y += y;
    r -> p2.y += y;
  return r;
}

Bool dentro( punto *p, rettangolo *r ){
  float x = p->x, y = p->y;
  if ( x <=  r->p2.x && x >=  r->p1.x && y <=  r->p2.y && y >=  r->p1.y )
    return VERO;
  else 
    return FALSO;
}
